VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Copyright (C) 2006 Kristian S. Stangeland

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Public Property Get Setting(Category As String, Name As String, DefaultValue) As Variant

    ' Retrive the setting
    Setting = GetSetting("InputEvents", Category, Name, DefaultValue)

End Property

Public Property Let Setting(Category As String, Name As String, DefaultValue, ByVal vNewValue As Variant)

    ' Save the setting
    SaveSetting "InputEvents", Category, Name, CStr(vNewValue)

End Property

Public Sub FormSave(refForm As Form, Category As String)

    Dim Control As Object, vData
    
    ' Go through all controls, ...
    For Each Control In refForm.Controls
    
        ' ... saving it if it has a tag-property
        If Control.Tag <> "" Then
    
            ' Retrieve the corect information
            vData = CallByName(Control, GetPropertyByControl(Control), VbGet)
        
            ' Save the data
            Setting(Category, Control.Tag, "") = vData
        
        End If
    
    Next

End Sub

Public Sub FormLoad(refForm As Form, Category As String)

    Dim Control As Object
    
    ' Go through all controls, ...
    For Each Control In refForm.Controls
    
        ' ... loading it if it has a tag-property
        If Control.Tag <> "" Then
    
            ' Retrieve the saved information and put it in the control
            CallByName Control, GetPropertyByControl(Control), VbLet, Setting(Category, _
                        Control.Tag, CallByName(Control, GetPropertyByControl(Control), VbGet))

        End If
    
    Next

End Sub

Private Function GetPropertyByControl(Control As Object) As String

    ' Return the property to use
    Select Case True
    Case TypeOf Control Is ComboBox: GetPropertyByControl = "ListIndex"
    Case TypeOf Control Is ListBox: GetPropertyByControl = "ListIndex"
    Case TypeOf Control Is CheckBox: GetPropertyByControl = "Value"
    Case TypeOf Control Is TextBox: GetPropertyByControl = "Text"
    End Select

End Function
