VERSION 5.00
Begin VB.Form frmReplay 
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Replay"
   ClientHeight    =   3255
   ClientLeft      =   45
   ClientTop       =   315
   ClientWidth     =   5535
   Icon            =   "frmReplay.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   217
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   369
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtInput 
      Height          =   285
      Index           =   2
      Left            =   2520
      TabIndex        =   7
      Text            =   "0"
      Top             =   1320
      Width           =   2415
   End
   Begin VB.TextBox txtInput 
      Height          =   285
      Index           =   1
      Left            =   2520
      TabIndex        =   6
      Text            =   "-1"
      Top             =   960
      Width           =   2415
   End
   Begin VB.TextBox txtInput 
      Height          =   285
      Index           =   0
      Left            =   2520
      TabIndex        =   5
      Text            =   "-1"
      Top             =   600
      Width           =   2415
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   3000
      TabIndex        =   1
      Top             =   2520
      Width           =   1575
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "&Start"
      Default         =   -1  'True
      Height          =   375
      Left            =   1080
      TabIndex        =   0
      Top             =   2520
      Width           =   1575
   End
   Begin VB.Label lblEstimatedTime 
      Alignment       =   2  'Center
      Caption         =   "&Estimated run time:"
      Height          =   255
      Left            =   0
      TabIndex        =   8
      Top             =   1920
      Width           =   5535
   End
   Begin VB.Label lblLoops 
      Caption         =   "&Loops (-1 is infinite):"
      Height          =   255
      Left            =   600
      TabIndex        =   4
      Top             =   1320
      Width           =   1815
   End
   Begin VB.Label lblEndIndex 
      Caption         =   "&End index:"
      Height          =   255
      Left            =   600
      TabIndex        =   3
      Top             =   960
      Width           =   1815
   End
   Begin VB.Label lblStart 
      Caption         =   "&Start index:"
      Height          =   255
      Left            =   600
      TabIndex        =   2
      Top             =   600
      Width           =   1815
   End
End
Attribute VB_Name = "frmReplay"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Copyright (C) 2006 Kristian. S.Stangeland

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

' The recorder to use when replaying
Public WithEvents refRecorder As clsRecorder
Attribute refRecorder.VB_VarHelpID = -1

' The current script control
Public ScriptControl As New ScriptControl

Private Sub cmdCancel_Click()

    ' Close this form
    Unload Me

End Sub

Private Sub cmdStart_Click()

    Dim Tell As Long, CurrentEvents As clsEvents, StoredEvents As clsEvents

    ' Don't allow the user to click this button again
    cmdStart.Enabled = False

    ' Let the user know we're replaying
    frmMain.statusBar.Panels(1).Text = "Replaying ..."
    
    ' Get the amount of times to loop
    Tell = Val(txtInput(2))
    
    ' Initialize the script if needed
    With refRecorder
        If .Events.EnableProcessor Then
        
            ' Take backup of the events
            Set CurrentEvents = .Events.CloneEvents
            Set StoredEvents = .Events
            Set .Events = CurrentEvents
            
            ' Initiate the script control
            ScriptControl.Reset
            ScriptControl.AddCode .Events.ElementProcessor
            ScriptControl.AddObject "StoredEvents", StoredEvents
            ScriptControl.AddObject "CurrentEvents", CurrentEvents
            
        End If
    End With

    ' Start replaying events
    Do
        refRecorder.ReplayEvents Val(txtInput(0)), Val(txtInput(1))
    
        ' Decrease the amount of loops left
        Tell = Tell - 1
    
    ' Stop looping when we've below 0
    Loop Until Tell = -1
    
    ' Swap back if needed
    If refRecorder.Events.EnableProcessor Then
        Set refRecorder.Events = StoredEvents
        Set CurrentEvents = Nothing
    End If
    
    ' Clear variables
    frmMain.statusBar.Panels(1).Text = ""

    ' Enable this button again
    cmdStart.Enabled = True

End Sub

Public Sub Update()

    ' Update the label
    txtInput_Change 0
    
End Sub

Private Sub refRecorder_ExecutingEvent(ByVal Index As Long, Cancel As Boolean)

    ' Save all errors in the log
    On Error GoTo Feil

    ' Firstly, see if we need to do anything
    If refRecorder.Events.EnableProcessor Then
    
        ' Process the event (and cancel, if told)
        Cancel = Not ScriptControl.Run("ElementInvoked", Index)
    
    End If

' *** Error handler ***
Exit Sub
Feil:

    ' Just use this for now
    Debug.Print Error

End Sub

Private Sub Form_Load()

    ' Set default values
    cmdStart.Enabled = True

    ' Initialize script control
    ScriptControl.Language = "VBScript"

    ' Initialize the language
    Language.ProcessForm Me

End Sub

Private Sub Form_Unload(Cancel As Integer)

    ' Cancel replay
    If Not (refRecorder Is Nothing) Then
        refRecorder.StopProcess
    End If

End Sub

Private Sub txtInput_Change(Index As Integer)

    ' Show the estimated time of running
    If Val(txtInput(2)) >= 0 Then
        lblEstimatedTime.Caption = "&Estimated run time: " & ConvertTime((CalculateDifference(refRecorder.Events, _
         Val(txtInput(0)), Val(txtInput(1))) * (Val(txtInput(2)) + 1)))
    Else
        lblEstimatedTime.Caption = "&Estimated run time: N/A"
    End If

End Sub

Private Sub txtInput_KeyPress(Index As Integer, KeyAscii As Integer)

    ' Filter out unwanted characters
    Select Case KeyAscii
    Case Is = 8, 45, 48 To 57
    Case Else: KeyAscii = 0
    End Select

End Sub

Private Function CalculateDifference(Events As clsEvents, ByVal StartIndex As Long, ByVal EndIndex As Long)

    ' Firstly, fix the indexes
    If StartIndex < 0 Then StartIndex = 0
    If EndIndex < 0 Then EndIndex = Events.EventCount - 1

    ' Return the difference in miliseconds
    CalculateDifference = Events.EventTime(EndIndex) - Events.EventTime(StartIndex)

End Function

Private Function ConvertTime(ByVal Miliseconds As Long) As String

    Dim aMeasurements(3) As Long, aConvert, aFormat, Tell As Long

    ' Initialize the array
    aConvert = Array(3600000, 60000, 1000, 1)
    aFormat = Array("00", "00", "00", "0000")
    
    ' Convert the different measurements
    For Tell = 0 To 3
        
        ' Calculate, ...
        aMeasurements(Tell) = Fix(Miliseconds / aConvert(Tell))
        Miliseconds = Miliseconds - (aMeasurements(Tell) * aConvert(Tell))
        
        ' Then add to the returning string
        ConvertTime = ConvertTime & Format(aMeasurements(Tell), aFormat(Tell)) & IIf(Tell < 3, ":", "")
        
    Next

End Function
