VERSION 5.00
Begin VB.Form frmSettings 
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Settings"
   ClientHeight    =   4185
   ClientLeft      =   45
   ClientTop       =   315
   ClientWidth     =   4860
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   279
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   324
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   3360
      TabIndex        =   11
      Top             =   3600
      Width           =   1215
   End
   Begin VB.CommandButton cmdOk 
      Caption         =   "&Ok"
      Default         =   -1  'True
      Height          =   375
      Left            =   2040
      TabIndex        =   10
      Top             =   3600
      Width           =   1215
   End
   Begin VB.Frame frameDetailSettings 
      Caption         =   "&Mouse detail:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1575
      Left            =   240
      TabIndex        =   4
      Top             =   1680
      Width           =   4335
      Begin VB.PictureBox picMouseDetail 
         BorderStyle     =   0  'None
         Height          =   1215
         Left            =   120
         ScaleHeight     =   81
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   273
         TabIndex        =   5
         Top             =   240
         Width           =   4095
         Begin VB.TextBox txtMouseDown 
            Height          =   285
            Left            =   2160
            TabIndex        =   9
            Top             =   720
            Width           =   1815
         End
         Begin VB.TextBox txtMouseUp 
            Height          =   285
            Left            =   2160
            TabIndex        =   8
            Top             =   360
            Width           =   1815
         End
         Begin VB.Label lblMouseDown 
            Caption         =   "&Detail at mouse down:"
            Height          =   255
            Left            =   120
            TabIndex        =   7
            Top             =   750
            Width           =   2055
         End
         Begin VB.Label lblMouseUp 
            Caption         =   "&Detail at mouse up:"
            Height          =   255
            Left            =   120
            TabIndex        =   6
            Top             =   375
            Width           =   2055
         End
      End
   End
   Begin VB.Frame frameLanguage 
      Caption         =   "&Language: "
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1335
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   4335
      Begin VB.PictureBox picLanguage 
         BorderStyle     =   0  'None
         Height          =   975
         Left            =   120
         ScaleHeight     =   65
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   273
         TabIndex        =   1
         Top             =   240
         Width           =   4095
         Begin VB.ComboBox cmdLanguage 
            Height          =   315
            Left            =   2160
            Style           =   2  'Dropdown List
            TabIndex        =   3
            Top             =   360
            Width           =   1815
         End
         Begin VB.Label lblLanguage 
            Caption         =   "&Select file:"
            Height          =   255
            Left            =   120
            TabIndex        =   2
            Top             =   390
            Width           =   1455
         End
      End
   End
End
Attribute VB_Name = "frmSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Copyright (C) 2006 Kristian. S.Stangeland

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

' Used in different file operations
Public FileOperation As New clsFileOperation

' The events with the desired settings
Public Events As clsEvents

Public Sub LoadSettings()

    Dim File, sName As String
    
    ' Clear the combobox
    cmdLanguage.Clear
    
    ' Go through all the language files
    For Each File In FileOperation.RetriveFileList(App.Path & "\Languages", "*.xml", False)
    
        ' Retrieve the language name
        sName = FileOperation.GetNoExtension(FileOperation.GetFileName(CStr(File)))
    
        ' Add the file name
        cmdLanguage.AddItem sName
    
        ' Select it if it is the current language
        If sName = Language.LanguageName Then
            cmdLanguage.ListIndex = cmdLanguage.ListCount - 1
        End If
    
    Next
    
    ' Then set the textboxes
    txtMouseUp.Text = Events.MouseUpDetail
    txtMouseDown.Text = Events.MouseDownDetail

End Sub

Public Sub SaveSettings()

    ' Save the language setting
    Settings.Setting("General", "Language", "") = cmdLanguage.Text

    ' Reload language
    LoadLanguage

    ' Save the textboxes
    Events.MouseUpDetail = Val(txtMouseUp.Text)
    Events.MouseDownDetail = Val(txtMouseDown.Text)
    
End Sub

Private Sub cmdCancel_Click()

    ' Just hide the form
    Unload Me

End Sub

Private Sub cmdOk_Click()

    ' Save the settings
    SaveSettings

    ' Hide form
    Unload Me

End Sub

Private Sub Form_Load()

    ' Initialize the language
    Language.ProcessForm Me

End Sub
